#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:20 2017

	.PUBLIC _gp_uart0_tx_address
	.PUBLIC _g_uart0_tx_count
	.PUBLIC _gp_uart0_rx_address
	.PUBLIC _g_uart0_rx_count
	.PUBLIC _g_uart0_rx_length
	.PUBLIC _R_SAU0_Create
	.PUBLIC _R_UART0_Create
	.PUBLIC _R_UART0_Start
	.PUBLIC _R_UART0_Stop
	.PUBLIC _R_UART0_Receive
	.PUBLIC _R_UART0_Send

	.SECTION .textf,TEXTF
_R_SAU0_Create:
	.STACK _R_SAU0_Create = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_cg_serial.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements device driver for Serial module.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_serial.h"
	;***       34 : /* Start user code for include. Do not edit comment generated here */
	;***       35 : /* End user code. Do not edit comment generated here */
	;***       36 : #include "r_cg_userdefine.h"
	;***       37 : 
	;***       38 : /***********************************************************************************************************************
	;***       39 : Pragma directive
	;***       40 : ***********************************************************************************************************************/
	;***       41 : /* Start user code for pragma. Do not edit comment generated here */
	;***       42 : /* End user code. Do not edit comment generated here */
	;***       43 : 
	;***       44 : /***********************************************************************************************************************
	;***       45 : Global variables and functions
	;***       46 : ***********************************************************************************************************************/
	;***       47 : volatile uint8_t * gp_uart0_tx_address;        /* uart0 transmit buffer address */
	;***       48 : volatile uint16_t  g_uart0_tx_count;           /* uart0 transmit data number */
	;***       49 : volatile uint8_t * gp_uart0_rx_address;        /* uart0 receive buffer address */
	;***       50 : volatile uint16_t  g_uart0_rx_count;           /* uart0 receive data number */
	;***       51 : volatile uint16_t  g_uart0_rx_length;          /* uart0 receive data length */
	;***       52 : /* Start user code for global. Do not edit comment generated here */
	;***       53 : /* End user code. Do not edit comment generated here */
	;***       54 : 
	;***       55 : /***********************************************************************************************************************
	;***       56 : * Function Name: R_SAU0_Create
	;***       57 : * Description  : This function initializes the SAU0 module.
	;***       58 : * Arguments    : None
	;***       59 : * Return Value : None
	;***       60 : ***********************************************************************************************************************/
	;***       61 : void R_SAU0_Create(void)
	;***       62 : {
	;***       63 :     SAU0EN = 1U;    /* supply SAU0 clock */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 63
	set1 !0x00F0.2
	;***       64 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 64
	nop
	;***       65 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 65
	nop
	;***       66 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 66
	nop
	;***       67 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 67
	nop
	movw ax, #0x0044
	;***       68 :     SPS0 = _0004_SAU_CK00_FCLK_4 | _0040_SAU_CK01_FCLK_4;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 68
	movw !0x0126, ax
	;***       69 :     R_UART0_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 69
	br $_R_UART0_Create
_R_UART0_Create:
	.STACK _R_UART0_Create = 4
	;***       70 : }
	;***       71 : 
	;***       72 : /***********************************************************************************************************************
	;***       73 : * Function Name: R_UART0_Create
	;***       74 : * Description  : This function initializes the UART0 module.
	;***       75 : * Arguments    : None
	;***       76 : * Return Value : None
	;***       77 : ***********************************************************************************************************************/
	;***       78 : void R_UART0_Create(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 78
	movw de, #0x0070
	;***       79 : {
	;***       80 :     ST0 |= _0002_SAU_CH1_STOP_TRG_ON | _0001_SAU_CH0_STOP_TRG_ON;    /* disable UART0 receive and transmit */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 80
	movw ax, [de+0xB4]
	xch a, x
	or a, #0x03
	xch a, x
	movw [de+0xB4], ax
	;***       81 :     STMK0 = 1U;    /* disable INTST0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 81
	set1 0xFFFE5.5
	;***       82 :     STIF0 = 0U;    /* clear INTST0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 82
	clr1 0xFFFE1.5
	;***       83 :     SRMK0 = 1U;    /* disable INTSR0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 83
	set1 0xFFFE5.6
	;***       84 :     SRIF0 = 0U;    /* clear INTSR0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 84
	clr1 0xFFFE1.6
	;***       85 :     SREMK0 = 1U;   /* disable INTSRE0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 85
	set1 0xFFFE5.7
	;***       86 :     SREIF0 = 0U;   /* clear INTSRE0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 86
	clr1 0xFFFE1.7
	;***       87 :     /* Set INTST0 low priority */
	;***       88 :     STPR10 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 88
	set1 0xFFFED.5
	;***       89 :     STPR00 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 89
	set1 0xFFFE9.5
	;***       90 :     /* Set INTSR0 low priority */
	;***       91 :     SRPR10 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 91
	set1 0xFFFED.6
	;***       92 :     SRPR00 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 92
	set1 0xFFFE9.6
	movw ax, #0x0022
	;***       93 :     SMR00 = _0020_SAU_SMRMN_INITIALVALUE | _0000_SAU_CLOCK_SELECT_CK00 | _0000_SAU_TRIGGER_SOFTWARE |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 93
	movw [de+0xA0], ax
	movw ax, #0x8097
	;***       94 :             _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
	;***       95 :     SCR00 = _8000_SAU_TRANSMISSION | _0000_SAU_INTSRE_MASK | _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 95
	movw [de+0xA8], ax
	;***       96 :             _0007_SAU_LENGTH_8;
	;***       97 :     SDR00 = _CE00_UART0_TRANSMIT_DIVISOR;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 97
	movw 0xFFF10, #0xCE00
	movw hl, #0x0070
	;***       98 :     NFEN0 |= _01_SAU_RXD0_FILTER_ON;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 98
	set1 [hl].0
	movw ax, #0x0007
	movw de, #0x0070
	;***       99 :     SIR01 = _0004_SAU_SIRMN_FECTMN | _0002_SAU_SIRMN_PECTMN | _0001_SAU_SIRMN_OVCTMN;    /* clear error flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 99
	movw [de+0x9A], ax
	movw ax, #0x0122
	;***      100 :     SMR01 = _0020_SAU_SMRMN_INITIALVALUE | _0000_SAU_CLOCK_SELECT_CK00 | _0100_SAU_TRIGGER_RXD | _0000_SAU_EDGE_FALL |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 100
	movw [de+0xA2], ax
	movw ax, #0x4097
	;***      101 :             _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
	;***      102 :     SCR01 = _4000_SAU_RECEPTION | _0000_SAU_INTSRE_MASK | _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 102
	movw [de+0xAA], ax
	;***      103 :             _0007_SAU_LENGTH_8;
	;***      104 :     SDR01 = _CE00_UART0_RECEIVE_DIVISOR;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 104
	movw 0xFFF12, #0xCE00
	;***      105 :     SO0 |= _0001_SAU_CH0_DATA_OUTPUT_1;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 105
	movw ax, [de+0xB8]
	xch a, x
	or a, #0x01
	xch a, x
	movw [de+0xB8], ax
	;***      106 :     SOL0 |= _0000_SAU_CHANNEL0_NORMAL;    /* output level normal */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 106
	movw ax, [de+0xC4]
	movw [de+0xC4], ax
	;***      107 :     SOE0 |= _0001_SAU_CH0_OUTPUT_ENABLE;    /* enable UART0 output */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 107
	movw ax, [de+0xBA]
	xch a, x
	or a, #0x01
	xch a, x
	movw [de+0xBA], ax
	;***      108 :     /* Set RxD0 pin */
	;***      109 :     PM1 |= 0x02U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 109
	set1 0xFFF21.1
	;***      110 :     /* Set TxD0 pin */
	;***      111 :     P1 |= 0x04U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 111
	set1 0xFFF01.2
	;***      112 :     PM1 &= 0xFBU;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 112
	clr1 0xFFF21.2
	ret
_R_UART0_Start:
	.STACK _R_UART0_Start = 4
	;***      113 : }
	;***      114 : 
	;***      115 : /***********************************************************************************************************************
	;***      116 : * Function Name: R_UART0_Start
	;***      117 : * Description  : This function starts the UART0 module operation.
	;***      118 : * Arguments    : None
	;***      119 : * Return Value : None
	;***      120 : ***********************************************************************************************************************/
	;***      121 : void R_UART0_Start(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 121
	movw de, #0x0122
	;***      122 : {
	;***      123 :     SO0 |= _0001_SAU_CH0_DATA_OUTPUT_1;    /* output level normal */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 123
	movw ax, [de+0x06]
	xch a, x
	or a, #0x01
	xch a, x
	movw [de+0x06], ax
	;***      124 :     SOE0 |= _0001_SAU_CH0_OUTPUT_ENABLE;    /* enable UART0 output */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 124
	movw ax, [de+0x08]
	xch a, x
	or a, #0x01
	xch a, x
	movw [de+0x08], ax
	;***      125 :     SS0 |= _0002_SAU_CH1_START_TRG_ON | _0001_SAU_CH0_START_TRG_ON;    /* enable UART0 receive and transmit */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 125
	movw ax, [de]
	xch a, x
	or a, #0x03
	xch a, x
	movw [de], ax
	;***      126 :     STIF0 = 0U;    /* clear INTST0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 126
	clr1 0xFFFE1.5
	;***      127 :     SRIF0 = 0U;    /* clear INTSR0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 127
	clr1 0xFFFE1.6
	;***      128 :     STMK0 = 0U;    /* enable INTST0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 128
	clr1 0xFFFE5.5
	;***      129 :     SRMK0 = 0U;    /* enable INTSR0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 129
	clr1 0xFFFE5.6
	ret
_R_UART0_Stop:
	.STACK _R_UART0_Stop = 4
	;***      130 : }
	;***      131 : 
	;***      132 : /***********************************************************************************************************************
	;***      133 : * Function Name: R_UART0_Stop
	;***      134 : * Description  : This function stops the UART0 module operation.
	;***      135 : * Arguments    : None
	;***      136 : * Return Value : None
	;***      137 : ***********************************************************************************************************************/
	;***      138 : void R_UART0_Stop(void)
	;***      139 : {
	;***      140 :     STMK0 = 1U;    /* disable INTST0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 140
	set1 0xFFFE5.5
	;***      141 :     SRMK0 = 1U;    /* disable INTSR0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 141
	set1 0xFFFE5.6
	movw de, #0x0124
	;***      142 :     ST0 |= _0002_SAU_CH1_STOP_TRG_ON | _0001_SAU_CH0_STOP_TRG_ON;    /* disable UART0 receive and transmit */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 142
	movw ax, [de]
	xch a, x
	or a, #0x03
	xch a, x
	movw [de], ax
	;***      143 :     SOE0 &= ~_0001_SAU_CH0_OUTPUT_ENABLE;    /* disable UART0 output */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 143
	movw ax, [de+0x06]
	xch a, x
	and a, #0xFE
	xch a, x
	movw [de+0x06], ax
	;***      144 :     STIF0 = 0U;    /* clear INTST0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 144
	clr1 0xFFFE1.5
	;***      145 :     SRIF0 = 0U;    /* clear INTSR0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 145
	clr1 0xFFFE1.6
	ret
_R_UART0_Receive:
	.STACK _R_UART0_Receive = 4
	;***      146 :    
	;***      147 : }
	;***      148 : 
	;***      149 : /***********************************************************************************************************************
	;***      150 : * Function Name: R_UART0_Receive
	;***      151 : * Description  : This function receives UART0 data.
	;***      152 : * Arguments    : rx_buf -
	;***      153 : *                    receive buffer pointer
	;***      154 : *                rx_num -
	;***      155 : *                    buffer size
	;***      156 : * Return Value : status -
	;***      157 : *                    MD_OK or MD_ARGERROR
	;***      158 : ***********************************************************************************************************************/
	;***      159 : MD_STATUS R_UART0_Receive(uint8_t * const rx_buf, uint16_t rx_num)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 159
	movw de, ax
	movw ax, bc
	;***      160 : {
	;***      161 :     MD_STATUS status = MD_OK;
	;***      162 : 
	;***      163 :     if (rx_num < 1U)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 163
	or a, x
	bnz $.BB@LABEL@5_2
.BB@LABEL@5_1:	; if_break_bb
	;***      164 :     {
	;***      165 :         status = MD_ARGERROR;
	;***      166 :     }
	;***      167 :     else
	;***      168 :     {
	;***      169 :         g_uart0_rx_count = 0U;
	;***      170 :         g_uart0_rx_length = rx_num;
	;***      171 :         gp_uart0_rx_address = rx_buf;
	;***      172 :     }
	;***      173 : 
	;***      174 :     return (status);
	;***      175 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 175
	movw ax, #0x0081
	ret
.BB@LABEL@5_2:	; if_else_bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 0
	clrw ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 169
	movw !LOWW(_g_uart0_rx_count), ax
	movw ax, bc
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 170
	movw !LOWW(_g_uart0_rx_length), ax
	movw ax, de
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 171
	movw !LOWW(_gp_uart0_rx_address), ax
	clrw ax
	ret
_R_UART0_Send:
	.STACK _R_UART0_Send = 4
	;***      176 : 
	;***      177 : /***********************************************************************************************************************
	;***      178 : * Function Name: R_UART0_Send
	;***      179 : * Description  : This function sends UART0 data.
	;***      180 : * Arguments    : tx_buf -
	;***      181 : *                    transfer buffer pointer
	;***      182 : *                tx_num -
	;***      183 : *                    buffer size
	;***      184 : * Return Value : status -
	;***      185 : *                    MD_OK or MD_ARGERROR
	;***      186 : ***********************************************************************************************************************/
	;***      187 : MD_STATUS R_UART0_Send(uint8_t * const tx_buf, uint16_t tx_num)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 187
	movw de, ax
	movw ax, bc
	;***      188 : {
	;***      189 :     MD_STATUS status = MD_OK;
	;***      190 : 
	;***      191 :     if (tx_num < 1U)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 191
	or a, x
	bnz $.BB@LABEL@6_2
.BB@LABEL@6_1:	; if_break_bb
	;***      192 :     {
	;***      193 :         status = MD_ARGERROR;
	;***      194 :     }
	;***      195 :     else
	;***      196 :     {
	;***      197 :         gp_uart0_tx_address = tx_buf;
	;***      198 :         g_uart0_tx_count = tx_num;
	;***      199 :         STMK0 = 1U;    /* disable INTST0 interrupt */
	;***      200 :         TXD0 = *gp_uart0_tx_address;
	;***      201 :         gp_uart0_tx_address++;
	;***      202 :         g_uart0_tx_count--;
	;***      203 :         STMK0 = 0U;    /* enable INTST0 interrupt */
	;***      204 :     }
	;***      205 : 
	;***      206 :     return (status);
	;***      207 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 207
	movw ax, #0x0081
	ret
.BB@LABEL@6_2:	; if_else_bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 0
	movw ax, de
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 197
	movw !LOWW(_gp_uart0_tx_address), ax
	movw ax, bc
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 198
	movw !LOWW(_g_uart0_tx_count), ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 199
	set1 0xFFFE5.5
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 200
	mov a, [de]
	mov 0xFFF10, a
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 201
	incw de
	movw ax, de
	movw !LOWW(_gp_uart0_tx_address), ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 202
	decw !LOWW(_g_uart0_tx_count)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial.c", 203
	clr1 0xFFFE5.5
	clrw ax
	ret
	;***      208 : 
	;***      209 : /* Start user code for adding. Do not edit comment generated here */
	;***      210 : /* End user code. Do not edit comment generated here */
	.SECTION .bss,BSS
	.ALIGN 2
_gp_uart0_tx_address:
	.DS (2)
	.ALIGN 2
_g_uart0_tx_count:
	.DS (2)
	.ALIGN 2
_gp_uart0_rx_address:
	.DS (2)
	.ALIGN 2
_g_uart0_rx_count:
	.DS (2)
	.ALIGN 2
_g_uart0_rx_length:
	.DS (2)
