#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:25 2017

	.EXTERN _gp_uart0_tx_address
	.EXTERN _g_uart0_tx_count
	.EXTERN _gp_uart0_rx_address
	.EXTERN _g_uart0_rx_count
	.EXTERN _g_uart0_rx_length
	.EXTERN _g_tx_ready_flag
	.EXTERN _g_rx_buff
	.EXTERN _g_rx_rdpt
	.EXTERN _g_rx_dtno
	.EXTERN _g_rx_status

	.SECTION .text,TEXT
_r_uart0_interrupt_receive@1	.vector 0x0020
_r_uart0_interrupt_receive@1:
	.STACK _r_uart0_interrupt_receive@1 = 16
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_cg_serial_user.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements device driver for Serial module.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_serial.h"
	;***       34 : /* Start user code for include. Do not edit comment generated here */
	;***       35 : /* End user code. Do not edit comment generated here */
	;***       36 : #include "r_cg_userdefine.h"
	;***       37 : 
	;***       38 : /***********************************************************************************************************************
	;***       39 : Pragma directive
	;***       40 : ***********************************************************************************************************************/
	;***       41 : #pragma interrupt r_uart0_interrupt_send(vect=INTST0)
	;***       42 : #pragma interrupt r_uart0_interrupt_receive(vect=INTSR0)
	;***       43 : /* Start user code for pragma. Do not edit comment generated here */
	;***       44 : /* End user code. Do not edit comment generated here */
	;***       45 : 
	;***       46 : /***********************************************************************************************************************
	;***       47 : Global variables and functions
	;***       48 : ***********************************************************************************************************************/
	;***       49 : extern volatile uint8_t * gp_uart0_tx_address;         /* uart0 send buffer address */
	;***       50 : extern volatile uint16_t  g_uart0_tx_count;            /* uart0 send data number */
	;***       51 : extern volatile uint8_t * gp_uart0_rx_address;         /* uart0 receive buffer address */
	;***       52 : extern volatile uint16_t  g_uart0_rx_count;            /* uart0 receive data number */
	;***       53 : extern volatile uint16_t  g_uart0_rx_length;           /* uart0 receive data length */
	;***       54 : /* Start user code for global. Do not edit comment generated here */
	;***       55 : extern volatile uint8_t g_tx_ready_flag;                /* M^tO     */
	;***       56 : extern volatile uint8_t g_rx_buff[16];                  /* MpOobt@     */
	;***       57 : extern volatile uint8_t g_rx_rdpt;                      /* f[^̓ǂݏo|C^ */
	;***       58 : extern volatile uint8_t g_rx_dtno;                      /* i[Ăf[^   */
	;***       59 : extern volatile uint8_t g_rx_status;                    /* MXe[^XtO     */
	;***       60 : /* End user code. Do not edit comment generated here */
	;***       61 : 
	;***       62 : /***********************************************************************************************************************
	;***       63 : * Function Name: r_uart0_interrupt_receive
	;***       64 : * Description  : This function is INTSR0 interrupt service routine.
	;***       65 : * Arguments    : None
	;***       66 : * Return Value : None
	;***       67 : ***********************************************************************************************************************/
	;***       68 : static void __near r_uart0_interrupt_receive(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 68
	push ax
	push bc
	push de
	push hl
	mov a, es
	mov x, a
	mov a, cs
	push ax
	push hl
	;***       69 : {
	;***       70 :     volatile uint8_t rx_data;
	;***       71 :     volatile uint8_t err_type;
	;***       72 :     
	;***       73 :     err_type = (uint8_t)(SSR01 & 0x0007U);
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 73
	movw ax, !0x0102
	mov a, x
	and a, #0x07
	mov [sp+0x00], a
	;***       74 :     SIR01 = (uint16_t)err_type;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 74
	mov a, [sp+0x00]
	shrw ax, 8+0x00000
	movw !0x010A, ax
	;***       75 : 
	;***       76 :     if (err_type != 0U)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 76
	mov a, [sp+0x00]
	cmp0 a
	bz $.BB@LABEL@1_2
.BB@LABEL@1_1:	; if_then_bb
	;***       77 :     {
	;***       78 :         r_uart0_callback_error(err_type);
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 78
	mov a, [sp+0x00]
	call !!_r_uart0_callback_error@1
.BB@LABEL@1_2:	; if_break_bb
	;***       79 :     }
	;***       80 :     
	;***       81 :     rx_data = RXD0;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 81
	mov a, 0xFFF12
	mov [sp+0x01], a
	;***       82 : 
	;***       83 :     if (g_uart0_rx_length > g_uart0_rx_count)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 83
	movw ax, !LOWW(_g_uart0_rx_length)
	cmpw ax, !LOWW(_g_uart0_rx_count)
	bnh $.BB@LABEL@1_6
.BB@LABEL@1_3:	; if_then_bb18
	;***       84 :     {
	;***       85 :         *gp_uart0_rx_address = rx_data;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 85
	movw de, !LOWW(_gp_uart0_rx_address)
	mov a, [sp+0x01]
	mov [de], a
	;***       86 :         gp_uart0_rx_address++;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 86
	incw !LOWW(_gp_uart0_rx_address)
	;***       87 :         g_uart0_rx_count++;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 87
	incw !LOWW(_g_uart0_rx_count)
	;***       88 : 
	;***       89 :         if (g_uart0_rx_length == g_uart0_rx_count)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 89
	movw ax, !LOWW(_g_uart0_rx_length)
	cmpw ax, !LOWW(_g_uart0_rx_count)
	sknz
.BB@LABEL@1_4:	; if_then_bb30
	;***       90 :         {
	;***       91 :             r_uart0_callback_receiveend();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 91
	call !!_r_uart0_callback_receiveend@1
.BB@LABEL@1_5:	; return
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 0
	pop hl
	pop ax
	mov cs, a
	mov a, x
	mov es, a
	pop hl
	pop de
	pop bc
	pop ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 98
	reti
.BB@LABEL@1_6:	; if_else_bb
	;***       92 :         }
	;***       93 :     }
	;***       94 :     else
	;***       95 :     {
	;***       96 :         r_uart0_callback_softwareoverrun(rx_data);
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 96
	mov a, [sp+0x01]
	shrw ax, 8+0x00000
	call !!_r_uart0_callback_softwareoverrun@1
	br $.BB@LABEL@1_5
_r_uart0_interrupt_send@1	.vector 0x001E
_r_uart0_interrupt_send@1:
	.STACK _r_uart0_interrupt_send@1 = 14
	;***       97 :     }
	;***       98 : }
	;***       99 : 
	;***      100 : /***********************************************************************************************************************
	;***      101 : * Function Name: r_uart0_interrupt_send
	;***      102 : * Description  : This function is INTST0 interrupt service routine.
	;***      103 : * Arguments    : None
	;***      104 : * Return Value : None
	;***      105 : ***********************************************************************************************************************/
	;***      106 : static void __near r_uart0_interrupt_send(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 106
	push ax
	push bc
	push de
	push hl
	mov a, es
	mov x, a
	mov a, cs
	push ax
	;***      107 : {
	;***      108 :     if (g_uart0_tx_count > 0U)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 108
	movw ax, !LOWW(_g_uart0_tx_count)
	or a, x
	bnz $.BB@LABEL@2_3
.BB@LABEL@2_1:	; if_else_bb
	;***      109 :     {
	;***      110 :         TXD0 = *gp_uart0_tx_address;
	;***      111 :         gp_uart0_tx_address++;
	;***      112 :         g_uart0_tx_count--;
	;***      113 :     }
	;***      114 :     else
	;***      115 :     {
	;***      116 :         r_uart0_callback_sendend();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 116
	call !!_r_uart0_callback_sendend@1
.BB@LABEL@2_2:	; if_else_bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 0
	pop ax
	mov cs, a
	mov a, x
	mov es, a
	pop hl
	pop de
	pop bc
	pop ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 118
	reti
.BB@LABEL@2_3:	; if_then_bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 110
	movw de, !LOWW(_gp_uart0_tx_address)
	mov a, [de]
	mov 0xFFF10, a
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 111
	incw de
	movw ax, de
	movw !LOWW(_gp_uart0_tx_address), ax
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 112
	decw !LOWW(_g_uart0_tx_count)
	br $.BB@LABEL@2_2
	.SECTION .textf,TEXTF
_r_uart0_callback_receiveend@1:
	.STACK _r_uart0_callback_receiveend@1 = 4
	;***      117 :     }
	;***      118 : }
	;***      119 : 
	;***      120 : /***********************************************************************************************************************
	;***      121 : * Function Name: r_uart0_callback_receiveend
	;***      122 : * Description  : This function is a callback function when UART0 finishes reception.
	;***      123 : * Arguments    : None
	;***      124 : * Return Value : None
	;***      125 : ***********************************************************************************************************************/
	;***      126 : static void r_uart0_callback_receiveend(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 126
	ret
_r_uart0_callback_softwareoverrun@1:
	.STACK _r_uart0_callback_softwareoverrun@1 = 6
	;***      127 : {
	;***      128 :     /* Start user code. Do not edit comment generated here */
	;***      129 :     /* End user code. Do not edit comment generated here */
	;***      130 : }
	;***      131 : 
	;***      132 : /***********************************************************************************************************************
	;***      133 : * Function Name: r_uart0_callback_softwareoverrun
	;***      134 : * Description  : This function is a callback function when UART0 receives an overflow data.
	;***      135 : * Arguments    : rx_data -
	;***      136 : *                    receive data
	;***      137 : * Return Value : None
	;***      138 : ***********************************************************************************************************************/
	;***      139 : static void r_uart0_callback_softwareoverrun(uint16_t rx_data)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 139
	push hl
	movw bc, ax
	;***      140 : {
	;***      141 :     /* Start user code. Do not edit comment generated here */
	;***      142 :     /* MpOobt@ */
	;***      143 : 
	;***      144 :     uint8_t  setptr;
	;***      145 : 
	;***      146 :     if ( g_rx_dtno < 16 )
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 146
	cmp !LOWW(_g_rx_dtno), #0x10
	bnc $.BB@LABEL@4_2
.BB@LABEL@4_1:	; if_then_bb
	;***      147 :     {                           /* obt@ɋ󂫂                       */
	;***      148 :         setptr = ((g_rx_rdpt + g_rx_dtno) & 0x0F);  /* ݃|C^     */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 148
	mov a, !LOWW(_g_rx_rdpt)
	add a, !LOWW(_g_rx_dtno)
	and a, #0x0F
	mov [sp+0x00], a
	;***      149 :         g_rx_buff[setptr] = rx_data;    /* Mf[^obt@Ɋi[       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 149
	mov a, c
	mov x, a
	mov a, [sp+0x00]
	mov b, a
	mov a, x
	mov LOWW(_g_rx_buff)[b], a
	;***      150 :         g_rx_dtno++;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 150
	inc !LOWW(_g_rx_dtno)
	pop hl
	ret
.BB@LABEL@4_2:	; if_else_bb
	;***      151 :     }
	;***      152 :     else
	;***      153 :     {                           /* obt@t̏                   */
	;***      154 :         g_rx_status = 0x80;             /* I[ot[EtOZbg     */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 154
	mov !LOWW(_g_rx_status), #0x80
	pop hl
	ret
_r_uart0_callback_sendend@1:
	.STACK _r_uart0_callback_sendend@1 = 4
	;***      155 :     }
	;***      156 : 
	;***      157 :     /* End user code. Do not edit comment generated here */
	;***      158 : }
	;***      159 : 
	;***      160 : /***********************************************************************************************************************
	;***      161 : * Function Name: r_uart0_callback_sendend
	;***      162 : * Description  : This function is a callback function when UART0 finishes transmission.
	;***      163 : * Arguments    : None
	;***      164 : * Return Value : None
	;***      165 : ***********************************************************************************************************************/
	;***      166 : static void r_uart0_callback_sendend(void)
	;***      167 : {
	;***      168 :     /* Start user code. Do not edit comment generated here */
	;***      169 :     g_tx_ready_flag = 0x01;             /* MtOZbg   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 169
	oneb !LOWW(_g_tx_ready_flag)
	ret
_r_uart0_callback_error@1:
	.STACK _r_uart0_callback_error@1 = 4
	;***      170 :     /* End user code. Do not edit comment generated here */
	;***      171 : }
	;***      172 : 
	;***      173 : /***********************************************************************************************************************
	;***      174 : * Function Name: r_uart0_callback_error
	;***      175 : * Description  : This function is a callback function when UART0 reception error occurs.
	;***      176 : * Arguments    : err_type -
	;***      177 : *                    error type value
	;***      178 : * Return Value : None
	;***      179 : ***********************************************************************************************************************/
	;***      180 : static void r_uart0_callback_error(uint8_t err_type)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_serial_user.c", 180
	ret
	;***      181 : {
	;***      182 :     /* Start user code. Do not edit comment generated here */
	;***      183 :     /* End user code. Do not edit comment generated here */
	;***      184 : }
	;***      185 : 
	;***      186 : /* Start user code for adding. Do not edit comment generated here */
	;***      187 : /* End user code. Do not edit comment generated here */
