#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:33 2017

	.PUBLIC _R_TAU0_Create
	.PUBLIC _R_TAU0_Channel1_Lower8bits_Start
	.PUBLIC _R_TAU0_Channel1_Lower8bits_Stop

	.SECTION .textf,TEXTF
_R_TAU0_Create:
	.STACK _R_TAU0_Create = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_cg_timer.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements device driver for TAU module.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_timer.h"
	;***       34 : /* Start user code for include. Do not edit comment generated here */
	;***       35 : /* End user code. Do not edit comment generated here */
	;***       36 : #include "r_cg_userdefine.h"
	;***       37 : 
	;***       38 : /***********************************************************************************************************************
	;***       39 : Pragma directive
	;***       40 : ***********************************************************************************************************************/
	;***       41 : /* Start user code for pragma. Do not edit comment generated here */
	;***       42 : /* End user code. Do not edit comment generated here */
	;***       43 : 
	;***       44 : /***********************************************************************************************************************
	;***       45 : Global variables and functions
	;***       46 : ***********************************************************************************************************************/
	;***       47 : /* Start user code for global. Do not edit comment generated here */
	;***       48 : /* End user code. Do not edit comment generated here */
	;***       49 : 
	;***       50 : /***********************************************************************************************************************
	;***       51 : * Function Name: R_TAU0_Create
	;***       52 : * Description  : This function initializes the TAU0 module.
	;***       53 : * Arguments    : None
	;***       54 : * Return Value : None
	;***       55 : ***********************************************************************************************************************/
	;***       56 : void R_TAU0_Create(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 56
	movw hl, #0x00F0
	;***       57 : {
	;***       58 :     TAU0EN = 1U;    /* supplies input clock */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 58
	set1 [hl].0
	clrw ax
	movw de, #0x00F0
	;***       59 :     TPS0 = _0000_TAU_CKM0_FCLK_0 | _0000_TAU_CKM1_FCLK_0 | _0000_TAU_CKM2_FCLK_1 | _0000_TAU_CKM3_FCLK_8;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 59
	movw [de+0xC6], ax
	movw ax, #0x0AFF
	;***       60 :     /* Stop all channels */
	;***       61 :     TT0 = _0001_TAU_CH0_STOP_TRG_ON | _0002_TAU_CH1_STOP_TRG_ON | _0004_TAU_CH2_STOP_TRG_ON |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 61
	movw [de+0xC4], ax
	;***       62 :           _0008_TAU_CH3_STOP_TRG_ON | _0010_TAU_CH4_STOP_TRG_ON | _0020_TAU_CH5_STOP_TRG_ON |
	;***       63 :           _0040_TAU_CH6_STOP_TRG_ON | _0080_TAU_CH7_STOP_TRG_ON | _0200_TAU_CH1_H8_STOP_TRG_ON |
	;***       64 :           _0800_TAU_CH3_H8_STOP_TRG_ON;
	;***       65 :     /* Mask channel 0 interrupt */
	;***       66 :     TMMK00 = 1U;    /* disable INTTM00 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 66
	set1 0xFFFE6.4
	;***       67 :     TMIF00 = 0U;    /* clear INTTM00 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 67
	clr1 0xFFFE2.4
	;***       68 :     /* Mask channel 1 interrupt */
	;***       69 :     TMMK01 = 1U;    /* disable INTTM01 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 69
	set1 0xFFFE6.5
	;***       70 :     TMIF01 = 0U;    /* clear INTTM01 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 70
	clr1 0xFFFE2.5
	;***       71 :     /* Mask channel 1 higher 8 bits interrupt */
	;***       72 :     TMMK01H = 1U;    /* disable INTTM01H interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 72
	set1 0xFFFE5.7
	;***       73 :     TMIF01H = 0U;    /* clear INTTM01H interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 73
	clr1 0xFFFE1.7
	;***       74 :     /* Mask channel 2 interrupt */
	;***       75 :     TMMK02 = 1U;    /* disable INTTM02 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 75
	set1 0xFFFE6.6
	;***       76 :     TMIF02 = 0U;    /* clear INTTM02 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 76
	clr1 0xFFFE2.6
	;***       77 :     /* Mask channel 3 interrupt */
	;***       78 :     TMMK03 = 1U;    /* disable INTTM03 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 78
	set1 0xFFFE6.7
	;***       79 :     TMIF03 = 0U;    /* clear INTTM03 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 79
	clr1 0xFFFE2.7
	;***       80 :     /* Mask channel 3 higher 8 bits interrupt */
	;***       81 :     TMMK03H = 1U;    /* disable INTTM03H interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 81
	set1 0xFFFE6.2
	;***       82 :     TMIF03H = 0U;    /* clear INTTM03H interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 82
	clr1 0xFFFE2.2
	;***       83 :     /* Mask channel 4 interrupt */
	;***       84 :     TMMK04 = 1U;    /* disable INTTM04 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 84
	set1 0xFFFE7.7
	;***       85 :     TMIF04 = 0U;    /* clear INTTM04 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 85
	clr1 0xFFFE3.7
	;***       86 :     /* Mask channel 5 interrupt */
	;***       87 :     TMMK05 = 1U;    /* disable INTTM05 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 87
	set1 0xFFFD4.0
	;***       88 :     TMIF05 = 0U;    /* clear INTTM05 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 88
	clr1 0xFFFD0.0
	;***       89 :     /* Mask channel 6 interrupt */
	;***       90 :     TMMK06 = 1U;    /* disable INTTM06 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 90
	set1 0xFFFD4.1
	;***       91 :     TMIF06 = 0U;    /* clear INTTM06 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 91
	clr1 0xFFFD0.1
	;***       92 :     /* Mask channel 7 interrupt */
	;***       93 :     TMMK07 = 1U;    /* disable INTTM07 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 93
	set1 0xFFFD4.2
	;***       94 :     TMIF07 = 0U;    /* clear INTTM07 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 94
	clr1 0xFFFD0.2
	movw ax, #0x4800
	;***       95 :     /* Channel 1 used as interval timer */
	;***       96 :     TMR01 = _4000_TAU_CLOCK_SELECT_CKM2 | _0000_TAU_CLOCK_MODE_CKS | _0800_TAU_8BITS_MODE | _0000_TAU_TRIGGER_SOFTWARE |
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 96
	movw [de+0xA2], ax
	;***       97 :             _0000_TAU_MODE_INTERVAL_TIMER | _0000_TAU_START_INT_UNUSED;
	;***       98 :     TDR01L = _27_TAU_TDR01L_VALUE;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 98
	mov 0xFFF1A, #0x27
	;***       99 :     TOM0 &= ~_0002_TAU_CH1_OUTPUT_COMBIN;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 99
	movw ax, [de+0xCE]
	xch a, x
	and a, #0xFD
	xch a, x
	movw [de+0xCE], ax
	;***      100 :     TOL0 &= ~_0002_TAU_CH1_OUTPUT_LEVEL_L;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 100
	movw ax, [de+0xCC]
	xch a, x
	and a, #0xFD
	xch a, x
	movw [de+0xCC], ax
	;***      101 :     TO0 &= ~_0002_TAU_CH1_OUTPUT_VALUE_1;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 101
	movw ax, [de+0xC8]
	xch a, x
	and a, #0xFD
	xch a, x
	movw [de+0xC8], ax
	;***      102 :     TOE0 &= ~_0002_TAU_CH1_OUTPUT_ENABLE;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 102
	movw ax, [de+0xCA]
	xch a, x
	and a, #0xFD
	xch a, x
	movw [de+0xCA], ax
	ret
_R_TAU0_Channel1_Lower8bits_Start:
	.STACK _R_TAU0_Channel1_Lower8bits_Start = 4
	;***      103 : }
	;***      104 : 
	;***      105 : /***********************************************************************************************************************
	;***      106 : * Function Name: R_TAU0_Channel1_Lower8bits_Start
	;***      107 : * Description  : This function starts TAU0 channel 1 Lower 8 bits counter.
	;***      108 : * Arguments    : None
	;***      109 : * Return Value : None
	;***      110 : ***********************************************************************************************************************/
	;***      111 : void R_TAU0_Channel1_Lower8bits_Start(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 111
	movw de, #0x01B2
	;***      112 : {
	;***      113 :     TS0 |= _0002_TAU_CH1_START_TRG_ON;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 113
	movw ax, [de]
	xch a, x
	or a, #0x02
	xch a, x
	movw [de], ax
	ret
_R_TAU0_Channel1_Lower8bits_Stop:
	.STACK _R_TAU0_Channel1_Lower8bits_Stop = 4
	;***      114 : }
	;***      115 : 
	;***      116 : /***********************************************************************************************************************
	;***      117 : * Function Name: R_TAU0_Channel1_Lower8bits_Stop
	;***      118 : * Description  : This function stops TAU0 channel 1 Lower 8 bits counter.
	;***      119 : * Arguments    : None
	;***      120 : * Return Value : None
	;***      121 : ***********************************************************************************************************************/
	;***      122 : void R_TAU0_Channel1_Lower8bits_Stop(void)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 122
	movw de, #0x01B4
	;***      123 : {
	;***      124 :     TT0 |= _0002_TAU_CH1_STOP_TRG_ON;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_timer.c", 124
	movw ax, [de]
	xch a, x
	or a, #0x02
	xch a, x
	movw [de], ax
	ret
	;***      125 : }
	;***      126 : 
	;***      127 : /* Start user code for adding. Do not edit comment generated here */
	;***      128 : /* End user code. Do not edit comment generated here */
