#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:17 2017

	.PUBLIC _R_Systeminit
	.EXTERN _R_CGC_Create
	.EXTERN _R_SAU0_Create
	.EXTERN _R_ADC_Create
	.EXTERN _R_TAU0_Create
	.EXTERN _R_DMAC0_Create
	.PUBLIC _hdwinit

	.SECTION .textf,TEXTF
_R_Systeminit:
	.STACK _R_Systeminit = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_systeminit.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements system initializing function.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_cgc.h"
	;***       34 : #include "r_cg_serial.h"
	;***       35 : #include "r_cg_adc.h"
	;***       36 : #include "r_cg_timer.h"
	;***       37 : #include "r_cg_dmac.h"
	;***       38 : /* Start user code for include. Do not edit comment generated here */
	;***       39 : /* End user code. Do not edit comment generated here */
	;***       40 : #include "r_cg_userdefine.h"
	;***       41 : 
	;***       42 : /***********************************************************************************************************************
	;***       43 : Pragma directive
	;***       44 : ***********************************************************************************************************************/
	;***       45 : /* Start user code for pragma. Do not edit comment generated here */
	;***       46 : /* End user code. Do not edit comment generated here */
	;***       47 : 
	;***       48 : /***********************************************************************************************************************
	;***       49 : Global variables and functions
	;***       50 : ***********************************************************************************************************************/
	;***       51 : /* Start user code for global. Do not edit comment generated here */
	;***       52 : /* End user code. Do not edit comment generated here */
	;***       53 : 
	;***       54 : /***********************************************************************************************************************
	;***       55 : * Function Name: R_Systeminit
	;***       56 : * Description  : This function initializes every macro.
	;***       57 : * Arguments    : None
	;***       58 : * Return Value : None
	;***       59 : ***********************************************************************************************************************/
	;***       60 : void R_Systeminit(void)
	;***       61 : {
	;***       62 :     PIOR = 0x00U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 62
	clrb !0x0077
	;***       63 :     R_CGC_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 63
	call !!_R_CGC_Create
	;***       64 :     R_SAU0_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 64
	call !!_R_SAU0_Create
	;***       65 :     R_ADC_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 65
	call !!_R_ADC_Create
	;***       66 :     R_TAU0_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 66
	call !!_R_TAU0_Create
	;***       67 :     R_DMAC0_Create();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 67
	call !!_R_DMAC0_Create
	;***       68 : 
	;***       69 :     IAWCTL = 0x00U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 69
	clrb !0x0078
	ret
_hdwinit:
	.STACK _hdwinit = 4
	;***       70 : }
	;***       71 : 
	;***       72 : 
	;***       73 : /***********************************************************************************************************************
	;***       74 : * Function Name: hdwinit
	;***       75 : * Description  : This function initializes hardware setting.
	;***       76 : * Arguments    : None
	;***       77 : * Return Value : None
	;***       78 : ***********************************************************************************************************************/
	;***       79 : void hdwinit(void)
	;***       80 : {
	;***       81 :     DI();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 81
	di
	;***       82 :     R_Systeminit();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_systeminit.c", 82
	br $_R_Systeminit
	;***       83 : }
	;***       84 : 
	;***       85 : /* Start user code for adding. Do not edit comment generated here */
	;***       86 : /* End user code. Do not edit comment generated here */
