#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:28 2017

	.PUBLIC _g_rx_buff
	.PUBLIC _g_rx_rdpt
	.PUBLIC _g_rx_dtno
	.PUBLIC _g_rx_status
	.PUBLIC _init_bf
	.PUBLIC _chk_status
	.PUBLIC _get_data
	.PUBLIC _get_blk

	.SECTION .textf,TEXTF
_init_bf:
	.STACK _init_bf = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /*******************************************************************************
	;***       21 : * File Name    : UART0.c
	;***       22 : * Device(s)    : R5F100LE
	;***       23 : * Tool-Chain   : CCRL
	;***       24 : * Description  : Oobt@̃T|[g֐ł
	;***       25 : * Creation Date: 2016/08/11
	;***       26 : *******************************************************************************/
	;***       27 : 
	;***       28 : /*******************************************************************************
	;***       29 : Includes
	;***       30 : *******************************************************************************/
	;***       31 : #include "r_cg_macrodriver.h"
	;***       32 : #include "UART0.h"
	;***       33 : #include "r_cg_userdefine.h"
	;***       34 : 
	;***       35 : /*******************************************************************************
	;***       36 : Pragma directive
	;***       37 : *******************************************************************************/
	;***       38 : 
	;***       39 : /*******************************************************************************
	;***       40 : Global variables and functions
	;***       41 : *******************************************************************************/
	;***       42 : volatile uint8_t g_rx_buff[16];                 /* MpOobt@     */
	;***       43 : volatile uint8_t g_rx_rdpt;                     /* f[^̓ǂݏo|C^ */
	;***       44 : volatile uint8_t g_rx_dtno;                     /* i[Ăf[^   */
	;***       45 : volatile uint8_t g_rx_status;                   /* MXe[^XtO     
	;***       46 :         bit7 : I[ot[EtO                                         */                                                                                                                          
	;***       47 : /*******************************************************************************
	;***       48 : * Function Name: init_bf
	;***       49 : * Description  : Oobt@̃|C^
	;***       50 : * Arguments    : None
	;***       51 : * Return Value : None
	;***       52 : *******************************************************************************/
	;***       53 : void init_bf(void)
	;***       54 : {
	;***       55 : 
	;***       56 :     SRMK0 = 1;                                  /* INTSR0Ƃ̔r       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 56
	set1 0xFFFE5.6
	;***       57 :     g_rx_rdpt = 0x00;                           /* ǂݏo|C^   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 57
	clrb !LOWW(_g_rx_rdpt)
	;***       58 :     g_rx_dtno = 0x00;                           /* f[^NA         */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 58
	clrb !LOWW(_g_rx_dtno)
	;***       59 :     g_rx_status = 0x00;                         /* Xe[^XNA       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 59
	clrb !LOWW(_g_rx_status)
	;***       60 :     SRMK0 = 0;                                  /* r䊮             */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 60
	clr1 0xFFFE5.6
	ret
_chk_status:
	.STACK _chk_status = 4
	;***       61 : 
	;***       62 : }
	;***       63 : 
	;***       64 : /*******************************************************************************
	;***       65 : * Function Name: chk_status
	;***       66 : * Description  : Oobt@̏ԊmF
	;***       67 : * Arguments    : None
	;***       68 : * Return Value : Mf[^+Xe[^X
	;***       69 : *               bit7 : I[ot[EtO
	;***       70 : *               bit6,5 : 0,0
	;***       71 : *               bit4-0 : f[^
	;***       72 : *******************************************************************************/
	;***       73 : uint8_t chk_status(void)
	;***       74 : {
	;***       75 :     uint8_t work;
	;***       76 : 
	;***       77 :     SRMK0 = 1;                                  /* INTSR0Ƃ̔r       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 77
	set1 0xFFFE5.6
	;***       78 :     work = g_rx_status;                         /* Xe[^Xǂݏo       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 78
	mov a, !LOWW(_g_rx_status)
	;***       79 :     g_rx_status = 0x00;                         /* Xe[^XNA       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 79
	clrb !LOWW(_g_rx_status)
	;***       80 :     work |= g_rx_dtno;                          /* f[^ǂݏo         */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 80
	or a, !LOWW(_g_rx_dtno)
	;***       81 :     SRMK0 = 0;                                  /* r䊮             */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 81
	clr1 0xFFFE5.6
	;***       82 :     return ( work );
	;***       83 : 
	;***       84 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 84
	ret
_get_data:
	.STACK _get_data = 4
	;***       85 : 
	;***       86 : /*******************************************************************************
	;***       87 : * Function Name: get_data
	;***       88 : * Description  : Oobt@1f[^ǂݏo
	;***       89 : * Arguments    : None
	;***       90 : * Return Value : f[^
	;***       91 : *******************************************************************************/
	;***       92 : uint8_t get_data(void)
	;***       93 : {
	;***       94 :     uint8_t work;
	;***       95 : 
	;***       96 :     if ( 0 == g_rx_dtno )
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 96
	cmp0 !LOWW(_g_rx_dtno)
	bnz $.BB@LABEL@3_2
.BB@LABEL@3_1:	; if_break_bb
	;***       97 :     {
	;***       98 :         work = 0x00;                            /* f[^Ȃ΁C0x00   */
	;***       99 :     }
	;***      100 :     else
	;***      101 :     {
	;***      102 :         work = g_rx_buff[g_rx_rdpt];            /* f[^̓ǂݏo         */
	;***      103 : 
	;***      104 :         SRMK0 = 1;                              /* INTSR0Ƃ̔r       */
	;***      105 :         g_rx_dtno--;
	;***      106 :         g_rx_rdpt++;                            /* |C^XV             */
	;***      107 :         g_rx_rdpt &= 0x0F;
	;***      108 :         SRMK0 = 0;                              /* r䊮             */
	;***      109 :     }
	;***      110 : 
	;***      111 :     return ( work );
	;***      112 : 
	;***      113 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 113
	clrb a
	ret
.BB@LABEL@3_2:	; if_else_bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 102
	mov b, !LOWW(_g_rx_rdpt)
	mov a, LOWW(_g_rx_buff)[b]
	mov x, a
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 104
	set1 0xFFFE5.6
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 105
	dec !LOWW(_g_rx_dtno)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 106
	inc !LOWW(_g_rx_rdpt)
	mov a, #0x0F
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 107
	and a, !LOWW(_g_rx_rdpt)
	mov !LOWW(_g_rx_rdpt), a
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 108
	clr1 0xFFFE5.6
	mov a, x
	ret
_get_blk:
	.STACK _get_blk = 8
	;***      114 : 
	;***      115 : /*******************************************************************************
	;***      116 : * Function Name: get_blk
	;***      117 : * Description  : Oobt@w肳ꂽf[^ǂݏoi]j
	;***      118 : * Arguments    : i[|C^Cf[^
	;***      119 : * Return Value : cf[^
	;***      120 : *******************************************************************************/
	;***      121 : uint8_t get_blk(uint8_t * const buff, uint8_t number)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 121
	subw sp, #0x04
	movw de, ax
	;***      122 : {
	;***      123 : 
	;***      124 :     uint8_t work;
	;***      125 :     uint8_t cnt;                                /* ]pJE^           */
	;***      126 :     uint8_t * gp_buff;                          /* ]p|C^           */
	;***      127 : 
	;***      128 :     work = number;                              /* vf[^Zbg     */
	;***      129 : 
	;***      130 :     if ( ( 0 != number ) && ( 0 != g_rx_dtno ) )
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 130
	cmp0 c
	bz $.BB@LABEL@4_9
.BB@LABEL@4_1:	; bb
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 0
	cmp0 !LOWW(_g_rx_dtno)
	bz $.BB@LABEL@4_9
.BB@LABEL@4_2:	; if_then_bb
	mov a, c
	;***      131 :     {                               /* ]f[^ꍇ                 */
	;***      132 : 
	;***      133 :         gp_buff = buff;                         /* ]|C^ݒ     */
	;***      134 : 
	;***      135 : /* ---------------------------------------------------------------------------
	;***      136 : 
	;***      137 :     ]f[^Zo
	;***      138 : 
	;***      139 : ----------------------------------------------------------------------------*/
	;***      140 : 
	;***      141 :         if ( number < g_rx_dtno )
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 141
	cmp a, !LOWW(_g_rx_dtno)
	bnc $.BB@LABEL@4_4
.BB@LABEL@4_3:	; if_then_bb.bb62.preheader_crit_edge
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 0
	clrb a
	mov [sp+0x00], a
	br $.BB@LABEL@4_5
.BB@LABEL@4_4:	; if_else_bb
	;***      142 :         {                           /* vf[^ʈȉ̏ꍇ           */
	;***      143 :             cnt = number;                       /* ]f[^Zbg     */
	;***      144 :             work = 0;                           /* cf[^0ɂ    */
	;***      145 :         }
	;***      146 :         else
	;***      147 :         {                           /* vf[^ʈȏ̏ꍇ           */
	;***      148 :             cnt = g_rx_dtno;                    /* ]̓obt@̑S */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 148
	mov x, !LOWW(_g_rx_dtno)
	;***      149 :             work = number - g_rx_dtno;          /* cf[^Zo       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 149
	sub a, !LOWW(_g_rx_dtno)
	mov [sp+0x00], a
	mov a, x
	mov c, a
.BB@LABEL@4_5:	; bb62.preheader
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 0
	mov a, c
	shrw ax, 8+0x00000
	movw hl, ax
	clrw ax
	movw [sp+0x02], ax
.BB@LABEL@4_6:	; bb62
	;***      150 :         }
	;***      151 : 
	;***      152 : /* ---------------------------------------------------------------------------
	;***      153 : 
	;***      154 :     f[^]
	;***      155 : 
	;***      156 : ----------------------------------------------------------------------------*/
	;***      157 : 
	;***      158 :         for (  ; cnt > 0 ; cnt-- )
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 158
	cmpw ax, hl
	bz $.BB@LABEL@4_8
.BB@LABEL@4_7:	; bb38
	;***      159 :         {
	;***      160 :             *gp_buff = g_rx_buff[g_rx_rdpt];    /* Oobt@]   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 160
	mov b, !LOWW(_g_rx_rdpt)
	mov a, LOWW(_g_rx_buff)[b]
	mov [de], a
	;***      161 :             SRMK0 = 1;                          /* INTSR0Ƃ̔r       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 161
	set1 0xFFFE5.6
	;***      162 :             g_rx_rdpt++;                        /* ǂݏo|C^XV   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 162
	inc !LOWW(_g_rx_rdpt)
	mov a, #0x0F
	;***      163 :             g_rx_rdpt &= 0x0F;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 163
	and a, !LOWW(_g_rx_rdpt)
	mov !LOWW(_g_rx_rdpt), a
	;***      164 :             g_rx_dtno--;                        /* f[^|1            */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 164
	dec !LOWW(_g_rx_dtno)
	;***      165 :             SRMK0 = 0;                          /* INTSR0Ƃ̔rI   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 165
	clr1 0xFFFE5.6
	movw ax, [sp+0x02]
	;***      166 :             gp_buff++;                          /* ]|C^XV       */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 166
	incw ax
	movw [sp+0x02], ax
	incw de
	br $.BB@LABEL@4_6
.BB@LABEL@4_8:	; bb62.if_break_bb69_crit_edge
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 0
	pop bc
	push bc
.BB@LABEL@4_9:	; if_break_bb69
	;***      167 : 
	;***      168 :         }
	;***      169 :     
	;***      170 : 
	;***      171 :     }
	;***      172 : 
	;***      173 :     return( work );
	;***      174 : 
	;***      175 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/UART0.c", 175
	mov a, c
	addw sp, #0x04
	ret
	.SECTION .bss,BSS
_g_rx_buff:
	.DS (16)
_g_rx_rdpt:
	.DS (1)
_g_rx_dtno:
	.DS (1)
_g_rx_status:
	.DS (1)
