#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:29 2017

	.PUBLIC _R_ADC_Create
	.PUBLIC _R_ADC_Start
	.PUBLIC _R_ADC_Stop
	.PUBLIC _R_ADC_Set_OperationOn
	.PUBLIC _R_ADC_Set_OperationOff
	.PUBLIC _R_ADC_Get_Result_8bit

	.SECTION .textf,TEXTF
_R_ADC_Create:
	.STACK _R_ADC_Create = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_cg_adc.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements device driver for ADC module.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_adc.h"
	;***       34 : /* Start user code for include. Do not edit comment generated here */
	;***       35 : /* End user code. Do not edit comment generated here */
	;***       36 : #include "r_cg_userdefine.h"
	;***       37 : 
	;***       38 : /***********************************************************************************************************************
	;***       39 : Pragma directive
	;***       40 : ***********************************************************************************************************************/
	;***       41 : /* Start user code for pragma. Do not edit comment generated here */
	;***       42 : /* End user code. Do not edit comment generated here */
	;***       43 : 
	;***       44 : /***********************************************************************************************************************
	;***       45 : Global variables and functions
	;***       46 : ***********************************************************************************************************************/
	;***       47 : /* Start user code for global. Do not edit comment generated here */
	;***       48 : /* End user code. Do not edit comment generated here */
	;***       49 : 
	;***       50 : /***********************************************************************************************************************
	;***       51 : * Function Name: R_ADC_Create
	;***       52 : * Description  : This function initializes the AD converter.
	;***       53 : * Arguments    : None
	;***       54 : * Return Value : None
	;***       55 : ***********************************************************************************************************************/
	;***       56 : void R_ADC_Create(void)
	;***       57 : {    
	;***       58 :     ADCEN = 1U;  /* supply AD clock */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 58
	set1 !0x00F0.5
	;***       59 :     ADM0 = _00_AD_ADM0_INITIALVALUE;  /* disable AD conversion and clear ADM0 register */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 59
	mov 0xFFF30, #0x00
	;***       60 :     ADMK = 1U;  /* disable INTAD interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 60
	set1 0xFFFE7.0
	;***       61 :     ADIF = 0U;  /* clear INTAD interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 61
	clr1 0xFFFE3.0
	mov a, #0x07
	;***       62 :     /* The reset status of ADPC is analog input, so it's unnecessary to set. */
	;***       63 :     /* Set ANI0 - ANI2 pin as analog input */
	;***       64 :     PM2 |= 0x07U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 64
	or a, !0xFF22
	mov 0xFFF22, a
	;***       65 :     ADM0 = _30_AD_CONVERSION_CLOCK_4 | _00_AD_TIME_MODE_NORMAL_1 | _00_AD_OPERMODE_SELECT;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 65
	mov 0xFFF30, #0x30
	;***       66 :     ADM1 = _80_AD_TRIGGER_HARDWARE_NOWAIT | _20_AD_CONVMODE_ONESELECT | _00_AD_TRIGGER_INTTM01;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 66
	mov 0xFFF32, #0xA0
	movw de, #0x0010
	;***       67 :     ADM2 = _00_AD_POSITIVE_VDD | _00_AD_NEGATIVE_VSS | _00_AD_AREA_MODE_1 | _01_AD_RESOLUTION_8BIT;          
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 67
	mov [de+0x00], #0x01
	;***       68 :     ADUL = _FF_AD_ADUL_VALUE;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 68
	mov [de+0x01], #0xFF
	;***       69 :     ADLL = _00_AD_ADLL_VALUE;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 69
	mov [de+0x02], #0x00
	;***       70 :     ADS = _02_AD_INPUT_CHANNEL_2;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 70
	mov 0xFFF31, #0x02
	ret
_R_ADC_Start:
	.STACK _R_ADC_Start = 4
	;***       71 : }
	;***       72 : 
	;***       73 : /***********************************************************************************************************************
	;***       74 : * Function Name: R_ADC_Start
	;***       75 : * Description  : This function starts the AD converter.
	;***       76 : * Arguments    : None
	;***       77 : * Return Value : None
	;***       78 : ***********************************************************************************************************************/
	;***       79 : void R_ADC_Start(void)
	;***       80 : {
	;***       81 :     ADCS = 1U;  /* enable AD conversion */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 81
	set1 0xFFF30.7
	ret
_R_ADC_Stop:
	.STACK _R_ADC_Stop = 4
	;***       82 : }
	;***       83 : 
	;***       84 : /***********************************************************************************************************************
	;***       85 : * Function Name: R_ADC_Stop
	;***       86 : * Description  : This function stops the AD converter.
	;***       87 : * Arguments    : None
	;***       88 : * Return Value : None
	;***       89 : ***********************************************************************************************************************/
	;***       90 : void R_ADC_Stop(void)
	;***       91 : {
	;***       92 :     ADCS = 0U;  /* disable AD conversion */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 92
	clr1 0xFFF30.7
	ret
_R_ADC_Set_OperationOn:
	.STACK _R_ADC_Set_OperationOn = 4
	;***       93 : }
	;***       94 : 
	;***       95 : /***********************************************************************************************************************
	;***       96 : * Function Name: R_ADC_Set_OperationOn
	;***       97 : * Description  : This function enables comparator operation.
	;***       98 : * Arguments    : None
	;***       99 : * Return Value : None
	;***      100 : ***********************************************************************************************************************/
	;***      101 : void R_ADC_Set_OperationOn(void)
	;***      102 : {
	;***      103 :     ADCE = 1U;  /* enable AD comparator */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 103
	set1 0xFFF30.0
	ret
_R_ADC_Set_OperationOff:
	.STACK _R_ADC_Set_OperationOff = 4
	;***      104 : }
	;***      105 : 
	;***      106 : /***********************************************************************************************************************
	;***      107 : * Function Name: R_ADC_Set_OperationOff
	;***      108 : * Description  : This function stops comparator operation.
	;***      109 : * Arguments    : None
	;***      110 : * Return Value : None
	;***      111 : ***********************************************************************************************************************/
	;***      112 : void R_ADC_Set_OperationOff(void)
	;***      113 : {
	;***      114 :     ADCE = 0U;  /* disable AD comparator */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 114
	clr1 0xFFF30.0
	ret
_R_ADC_Get_Result_8bit:
	.STACK _R_ADC_Get_Result_8bit = 4
	;***      115 : }
	;***      116 : 
	;***      117 : /***********************************************************************************************************************
	;***      118 : * Function Name: R_ADC_Get_Result_8bit
	;***      119 : * Description  : This function returns the higher 8 bits conversion result.
	;***      120 : * Arguments    : buffer -
	;***      121 : *                    the address where to write the conversion result
	;***      122 : * Return Value : None
	;***      123 : ***********************************************************************************************************************/
	;***      124 : void R_ADC_Get_Result_8bit(uint8_t * const buffer)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 124
	movw de, ax
	;***      125 : {
	;***      126 :     *buffer = ADCRH;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_adc.c", 126
	mov a, 0xFFF1F
	mov [de], a
	ret
	;***      127 : }
	;***      128 : 
	;***      129 : /* Start user code for adding. Do not edit comment generated here */
	;***      130 : /* End user code. Do not edit comment generated here */
