#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:35 2017

	.EXTERN _g_AdResult
	.PUBLIC _R_DMAC0_Create
	.PUBLIC _R_DMAC0_Start
	.PUBLIC _R_DMAC0_Stop
	.PUBLIC _R_DMAC0_UserInit
	.PUBLIC _R_DMAC0_Is_Running

	.SECTION .textf,TEXTF
_R_DMAC0_Create:
	.STACK _R_DMAC0_Create = 4
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_cg_dmac.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements device driver for DMAC module.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_dmac.h"
	;***       34 : /* Start user code for include. Do not edit comment generated here */
	;***       35 : /* End user code. Do not edit comment generated here */
	;***       36 : #include "r_cg_userdefine.h"
	;***       37 : 
	;***       38 : /***********************************************************************************************************************
	;***       39 : Pragma directive
	;***       40 : ***********************************************************************************************************************/
	;***       41 : /* Start user code for pragma. Do not edit comment generated here */
	;***       42 : /* End user code. Do not edit comment generated here */
	;***       43 : 
	;***       44 : /***********************************************************************************************************************
	;***       45 : Global variables and functions
	;***       46 : ***********************************************************************************************************************/
	;***       47 : /* Start user code for global. Do not edit comment generated here */
	;***       48 : /* End user code. Do not edit comment generated here */
	;***       49 : 
	;***       50 : /***********************************************************************************************************************
	;***       51 : * Function Name: R_DMAC0_Create
	;***       52 : * Description  : This function initializes the DMA0 transfer.
	;***       53 : * Arguments    : None
	;***       54 : * Return Value : None
	;***       55 : ***********************************************************************************************************************/
	;***       56 : void R_DMAC0_Create(void)
	;***       57 : {
	;***       58 :     DRC0 = _80_DMA_OPERATION_ENABLE;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 58
	mov 0xFFFBC, #0x80
	;***       59 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 59
	nop
	;***       60 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 60
	nop
	;***       61 :     DMAMK0 = 1U; /* disable INTDMA0 interrupt */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 61
	set1 0xFFFE5.3
	;***       62 :     DMAIF0 = 0U; /* clear INTDMA0 interrupt flag */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 62
	clr1 0xFFFE1.3
	;***       63 :     DMC0 = _00_DMA_TRANSFER_DIR_SFR2RAM | _00_DMA_DATA_SIZE_8 | _01_DMA_TRIGGER_AD;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 63
	mov 0xFFFBA, #0x01
	;***       64 :     DSA0 = _1F_DMA0_SFR_ADDRESS;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 64
	mov 0xFFFB0, #0x1F
	;***       65 :     DRA0 = _FEDF_DMA0_RAM_ADDRESS;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 65
	movw 0xFFFB2, #0xFEDF
	;***       66 :     DBC0 = _0001_DMA0_BYTE_COUNT;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 66
	movw 0xFFFB6, #0x0001
	;***       67 :     DEN0 = 0U; /* disable DMA0 operation */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 67
	clr1 0xFFFBC.7
	ret
_R_DMAC0_Start:
	.STACK _R_DMAC0_Start = 4
	;***       68 : }
	;***       69 : 
	;***       70 : /***********************************************************************************************************************
	;***       71 : * Function Name: R_DMAC0_Start
	;***       72 : * Description  : This function enables DMA0 transfer.
	;***       73 : * Arguments    : None
	;***       74 : * Return Value : None
	;***       75 : ***********************************************************************************************************************/
	;***       76 : void R_DMAC0_Start(void)
	;***       77 : {
	;***       78 :     DEN0 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 78
	set1 0xFFFBC.7
	;***       79 :     DST0 = 1U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 79
	set1 0xFFFBC.0
	ret
_R_DMAC0_Stop:
	.STACK _R_DMAC0_Stop = 4
	;***       80 : }
	;***       81 : 
	;***       82 : /***********************************************************************************************************************
	;***       83 : * Function Name: R_DMAC0_Stop
	;***       84 : * Description  : This function disables DMA0 transfer.
	;***       85 : * Arguments    : None
	;***       86 : * Return Value : None
	;***       87 : ***********************************************************************************************************************/
	;***       88 : void R_DMAC0_Stop(void)
	;***       89 : {
	;***       90 :     if (DST0 != 0U)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 90
	mov1 CY, 0xFFFBC.0
	sknc
.BB@LABEL@3_1:	; if_then_bb
	;***       91 :     {
	;***       92 :         DST0 = 0U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 92
	clr1 0xFFFBC.0
.BB@LABEL@3_2:	; if_break_bb
	;***       93 :     }
	;***       94 :     
	;***       95 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 95
	nop
	;***       96 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 96
	nop
	;***       97 :     DEN0 = 0U; /* disable DMA0 operation */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 97
	clr1 0xFFFBC.7
	ret
_R_DMAC0_UserInit:
	.STACK _R_DMAC0_UserInit = 4
	;***       98 : }
	;***       99 : 
	;***      100 : /* Start user code for adding. Do not edit comment generated here */
	;***      101 : extern volatile uint8_t g_AdResult[1024];
	;***      102 : /******************************************************************************
	;***      103 : * Function Name: R_DMAC0_UserInit
	;***      104 : * Description : This function re-initialize DMA0.
	;***      105 : * Arguments    : None
	;***      106 : * Return Value : None
	;***      107 : ******************************************************************************/
	;***      108 : void R_DMAC0_UserInit(void)
	;***      109 : {
	;***      110 :     DEN0    = 1U;                       /* Enable DMA0 operation */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 110
	set1 0xFFFBC.7
	;***      111 :     DRA0   = (uint16_t)&g_AdResult;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 111
	movw 0xFFFB2, #LOWW(_g_AdResult)
	;***      112 :     DBC0   = 100;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 112
	movw 0xFFFB6, #0x0064
	;***      113 :     DEN0    = 0U;                       /* Disable DMA0 operation */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 113
	clr1 0xFFFBC.7
	ret
_R_DMAC0_Is_Running:
	.STACK _R_DMAC0_Is_Running = 4
	;***      114 : }
	;***      115 : /******************************************************************************
	;***      116 : * Function Name: R_DMAC0_Is_Running
	;***      117 : * Description : This function returns whether DMA0 is running or not.
	;***      118 : * Arguments    : None
	;***      119 : * Return Value : true (DMAC0 is running) / false (DMAC0 is not running)
	;***      120 : ******************************************************************************/
	;***      121 : int8_t R_DMAC0_Is_Running(void)
	;***      122 : {
	;***      123 :     return (DST0 != 0U) ? 1U : 0U;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 123
	mov1 CY, 0xFFFBC.0
	onew ax
	skc
.BB@LABEL@5_1:	; bb7
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 0
	clrw ax
.BB@LABEL@5_2:	; bb8
	mov a, x
	;***      124 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_cg_dmac.c", 124
	ret
	;***      125 : /* End user code. Do not edit comment generated here */
