#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.02.00 [21 Aug 2015]
#@  Commmand :
#@   r_main.c
#@   r_systeminit.c
#@   r_cg_cgc.c
#@   r_cg_cgc_user.c
#@   r_cg_serial.c
#@   r_cg_serial_user.c
#@   UART0.c
#@   r_cg_adc.c
#@   r_cg_adc_user.c
#@   r_cg_timer.c
#@   r_cg_timer_user.c
#@   r_cg_dmac.c
#@   r_cg_dmac_user.c
#@   -cpu=S2
#@   -cref=DefaultBuild
#@   -obj_path=DefaultBuild
#@   -dev=E:\tools\micom\Renesas\CS+\CC\Device\RL78\Devicefile\DR5F100LG.DVF
#@   -c
#@   -g
#@   -g_line
#@   -I .
#@   -pass_source
#@   -asm_path=DefaultBuild
#@  compiled at Tue Mar 21 21:48:15 2017

	.PUBLIC _g_AdResult
	.PUBLIC _g_rx_ready_flag
	.PUBLIC _g_tx_ready_flag
	.PUBLIC _main
	.PUBLIC _R_MAIN_UserInit
	.EXTERN _R_ADC_Set_OperationOn
	.EXTERN _R_DMAC0_UserInit
	.EXTERN _R_DMAC0_Start
	.EXTERN _R_ADC_Start
	.EXTERN _R_TAU0_Channel1_Lower8bits_Start
	.EXTERN _R_DMAC0_Is_Running
	.EXTERN _R_TAU0_Channel1_Lower8bits_Stop
	.EXTERN _R_ADC_Stop
	.EXTERN _R_DMAC0_Stop
	.EXTERN _printf
	.EXTERN _scanf
	.EXTERN _R_UART0_Start
	.EXTERN _init_bf
	.PUBLIC _putchar
	.EXTERN _R_UART0_Send
	.PUBLIC _getchar
	.EXTERN _chk_status
	.EXTERN _get_data

	.SECTION .textf,TEXTF
_main:
	.STACK _main = 12
	;***        1 : /***********************************************************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
	;***        4 : * No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
	;***        5 : * applicable laws, including copyright laws. 
	;***        6 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
	;***        7 : * OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	;***        8 : * NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
	;***        9 : * LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
	;***       10 : * INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
	;***       11 : * ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       12 : * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
	;***       13 : * of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
	;***       14 : * following link:
	;***       15 : * http://www.renesas.com/disclaimer
	;***       16 : *
	;***       17 : * Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
	;***       18 : ***********************************************************************************************************************/
	;***       19 : 
	;***       20 : /***********************************************************************************************************************
	;***       21 : * File Name    : r_main.c
	;***       22 : * Version      : CodeGenerator for RL78/G13 V2.03.04.01 [11 Nov 2016]
	;***       23 : * Device(s)    : R5F100LG
	;***       24 : * Tool-Chain   : CCRL
	;***       25 : * Description  : This file implements main function.
	;***       26 : * Creation Date: 
	;***       27 : ***********************************************************************************************************************/
	;***       28 : 
	;***       29 : /***********************************************************************************************************************
	;***       30 : Includes
	;***       31 : ***********************************************************************************************************************/
	;***       32 : #include "r_cg_macrodriver.h"
	;***       33 : #include "r_cg_cgc.h"
	;***       34 : #include "r_cg_serial.h"
	;***       35 : #include "r_cg_adc.h"
	;***       36 : #include "r_cg_timer.h"
	;***       37 : #include "r_cg_dmac.h"
	;***       38 : /* Start user code for include. Do not edit comment generated here */
	;***       39 : #include "UART0.h"
	;***       40 : #include <stdio.h>
	;***       41 : /* End user code. Do not edit comment generated here */
	;***       42 : #include "r_cg_userdefine.h"
	;***       43 : 
	;***       44 : /***********************************************************************************************************************
	;***       45 : Pragma directive
	;***       46 : ***********************************************************************************************************************/
	;***       47 : /* Start user code for pragma. Do not edit comment generated here */
	;***       48 : /* End user code. Do not edit comment generated here */
	;***       49 : 
	;***       50 : /***********************************************************************************************************************
	;***       51 : Global variables and functions
	;***       52 : ***********************************************************************************************************************/
	;***       53 : /* Start user code for global. Do not edit comment generated here */
	;***       54 : volatile uint8_t g_AdResult[1024];      /* A/DϊDMA] */
	;***       55 : volatile uint8_t g_rx_ready_flag;       /* MtO       */
	;***       56 : volatile uint8_t static g_rx_buff2[16]; /* Mf[^Eobt@ */
	;***       57 : volatile uint8_t g_tx_ready_flag;       /* M\tO       */
	;***       58 : volatile uint8_t static g_tx_buff[16];  /* Mf[^Eobt@ */
	;***       59 : /* End user code. Do not edit comment generated here */
	;***       60 : void R_MAIN_UserInit(void);
	;***       61 : 
	;***       62 : /***********************************************************************************************************************
	;***       63 : * Function Name: main
	;***       64 : * Description  : This function implements main function.
	;***       65 : * Arguments    : None
	;***       66 : * Return Value : None
	;***       67 : ***********************************************************************************************************************/
	;***       68 : void main(void)
	;***       69 : {
	;***       70 :     R_MAIN_UserInit();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 70
	call $!_R_MAIN_UserInit
	;***       71 :     /* Start user code. Do not edit comment generated here */
	;***       72 :     {
	;***       73 :         int count;
	;***       74 : 
	;***       75 :         R_ADC_Set_OperationOn();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 75
	call !!_R_ADC_Set_OperationOn
	movw ax, #0x0020
.BB@LABEL@1_1:	; bb
	;***       76 :         for (count = 0U ; count < 32U ; count++)    /* Waiting for comparator stabilizing */
	;***       77 :         {
	;***       78 :             NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 78
	nop
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 76
	addw ax, #0xFFFF
	bnz $.BB@LABEL@1_1
.BB@LABEL@1_2:	; bb32
	;***       79 :         }
	;***       80 : 
	;***       81 :         for (;;)
	;***       82 :         {
	;***       83 :             R_DMAC0_UserInit();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 83
	call !!_R_DMAC0_UserInit
	;***       84 : 
	;***       85 :             /* --- Start TAU and A/D Convert and DMA --- */
	;***       86 :             R_DMAC0_Start();                        /* Enable DMA : Start waiting DMA trigger */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 86
	call !!_R_DMAC0_Start
	;***       87 :             R_ADC_Start();                          /* Enable A/D : Start waiting A/D trigger */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 87
	call !!_R_ADC_Start
	;***       88 :             R_TAU0_Channel1_Lower8bits_Start();     /* Start! */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 88
	call !!_R_TAU0_Channel1_Lower8bits_Start
	;***       89 : 
	;***       90 :             /* --- A/D converting now --- */
	;***       91 :             NOP();  /* for breakpoint, start singnal input on Simulator GUI */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 91
	nop
.BB@LABEL@1_3:	; bb10
	;***       92 :             while (R_DMAC0_Is_Running())
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 92
	call !!_R_DMAC0_Is_Running
	cmp0 a
	bnz $.BB@LABEL@1_3
.BB@LABEL@1_4:	; bb16
	;***       93 :             {
	;***       94 :                 ;
	;***       95 :             }
	;***       96 :             NOP();  /* for breakpoint, check timing chart on Simulator GUI */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 96
	nop
	;***       97 : 
	;***       98 :             /* --- Stop TAU and A/D Convert and DMA --- */
	;***       99 :             R_TAU0_Channel1_Lower8bits_Stop();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 99
	call !!_R_TAU0_Channel1_Lower8bits_Stop
	;***      100 :             R_ADC_Stop();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 100
	call !!_R_ADC_Stop
	;***      101 :             R_DMAC0_Stop();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 101
	call !!_R_DMAC0_Stop
	;***      102 : 
	;***      103 :             printf( "g_AdResult[100]=%d, %d, %d, ... %d\nPlease click [Send] button for next trial\n\n", g_AdResult[0], g_AdResult[1], g_AdResult[2], g_AdResult[99] );
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 103
	mov a, !LOWW(_g_AdResult)
	mov d, a
	mov c, !LOWW(_g_AdResult+0x00001)
	mov b, !LOWW(_g_AdResult+0x00002)
	mov a, !LOWW(_g_AdResult+0x00063)
	shrw ax, 8+0x00000
	push ax
	mov a, b
	shrw ax, 8+0x00000
	push ax
	mov a, c
	shrw ax, 8+0x00000
	push ax
	mov a, d
	shrw ax, 8+0x00000
	push ax
	movw de, #SMRLW(.STR@1)
	mov a, #0x0F
	call !!_printf
	addw sp, #0x08
	;***      104 :             scanf( "%*[^\n]" );
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 104
	movw de, #SMRLW(.STR@147)
	mov a, #0x0F
	call !!_scanf
	br $.BB@LABEL@1_2
_R_MAIN_UserInit:
	.STACK _R_MAIN_UserInit = 4
	;***      105 :         }
	;***      106 :     }
	;***      107 :     /* End user code. Do not edit comment generated here */
	;***      108 : }
	;***      109 : 
	;***      110 : /***********************************************************************************************************************
	;***      111 : * Function Name: R_MAIN_UserInit
	;***      112 : * Description  : This function adds user code before implementing main function.
	;***      113 : * Arguments    : None
	;***      114 : * Return Value : None
	;***      115 : ***********************************************************************************************************************/
	;***      116 : void R_MAIN_UserInit(void)
	;***      117 : {
	;***      118 :     /* Start user code. Do not edit comment generated here */
	;***      119 :     R_UART0_Start();            /* UART0N            */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 119
	call !!_R_UART0_Start
	;***      120 :     init_bf();                  /* Oobt@   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 120
	call !!_init_bf
	;***      121 :     g_tx_ready_flag = 0x01;     /* MtOZbg   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 121
	oneb !LOWW(_g_tx_ready_flag)
	;***      122 :     EI();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 122
	ei
	ret
_putchar:
	.STACK _putchar = 6
	;***      123 :     /* End user code. Do not edit comment generated here */
	;***      124 : }
	;***      125 : 
	;***      126 : /* Start user code for adding. Do not edit comment generated here */
	;***      127 : /***********************************************************************************************************************
	;***      128 : * Function Name: putchar
	;***      129 : * Description  : Low level layer for printf and puts
	;***      130 : ***********************************************************************************************************************/
	;***      131 : int putchar(int c)
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 131
	push hl
	movw [sp+0x00], ax
.BB@LABEL@3_1:	; bb2
	;***      132 : {
	;***      133 :     while( 0x00 == g_tx_ready_flag )        /* M҂             */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 133
	cmp0 !LOWW(_g_tx_ready_flag)
	bnz $.BB@LABEL@3_3
.BB@LABEL@3_2:	; bb
	;***      134 :     {
	;***      135 :         NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 135
	nop
	br $.BB@LABEL@3_1
.BB@LABEL@3_3:	; bb7
	;***      136 :     }
	;***      137 :     g_tx_ready_flag = 0x00;                 /* MtONA   */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 137
	clrb !LOWW(_g_tx_ready_flag)
	;***      138 :     R_UART0_Send( (uint8_t *)&c, 1 );       /* f[^MJn */
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 138
	onew bc
	movw ax, sp
	call !!_R_UART0_Send
	;***      139 :     return c;
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 139
	movw ax, [sp+0x00]
	;***      140 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 140
	pop hl
	ret
_getchar:
	.STACK _getchar = 4
.BB@LABEL@4_1:	; bb
	;***      141 : 
	;***      142 : /***********************************************************************************************************************
	;***      143 : * Function Name: getchar
	;***      144 : * Description  : Low level layer for scanf and gets
	;***      145 : ***********************************************************************************************************************/
	;***      146 : int getchar(void)
	;***      147 : {
	;***      148 :     while ( 0x00 == chk_status() );
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 148
	call !!_chk_status
	cmp0 a
	bz $.BB@LABEL@4_1
.BB@LABEL@4_2:	; bb5
	;***      149 :     NOP();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 149
	nop
	;***      150 :     return get_data();
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 150
	call !!_get_data
	shrw ax, 8+0x00000
	;***      151 : }
	.LINE "C:/Renesas/GR/rl78g13_tau_ad_dmac_study/r_main.c", 151
	ret
	;***      152 : /* End user code. Do not edit comment generated here */
	.SECTION .bss,BSS
_g_AdResult:
	.DS (1024)
_g_rx_ready_flag:
	.DS (1)
_g_tx_ready_flag:
	.DS (1)
	.SECTION .const,CONST
.STR@1:
	.DB 0x67
	.DB 0x5F
	.DB 0x41
	.DB 0x64
	.DB 0x52
	.DB 0x65
	.DB 0x73
	.DB 0x75
	.DB 0x6C
	.DB 0x74
	.DB 0x5B
	.DB 0x31
	.DB 0x30
	.DB 0x30
	.DB 0x5D
	.DB 0x3D
	.DB 0x25
	.DB 0x64
	.DB 0x2C
	.DB 0x20
	.DB 0x25
	.DB 0x64
	.DB 0x2C
	.DB 0x20
	.DB 0x25
	.DB 0x64
	.DB 0x2C
	.DB 0x20
	.DB 0x2E
	.DB 0x2E
	.DB 0x2E
	.DB 0x20
	.DB 0x25
	.DB 0x64
	.DB 0x0A
	.DB 0x50
	.DB 0x6C
	.DB 0x65
	.DB 0x61
	.DB 0x73
	.DB 0x65
	.DB 0x20
	.DB 0x63
	.DB 0x6C
	.DB 0x69
	.DB 0x63
	.DB 0x6B
	.DB 0x20
	.DB 0x5B
	.DB 0x53
	.DB 0x65
	.DB 0x6E
	.DB 0x64
	.DB 0x5D
	.DB 0x20
	.DB 0x62
	.DB 0x75
	.DB 0x74
	.DB 0x74
	.DB 0x6F
	.DB 0x6E
	.DB 0x20
	.DB 0x66
	.DB 0x6F
	.DB 0x72
	.DB 0x20
	.DB 0x6E
	.DB 0x65
	.DB 0x78
	.DB 0x74
	.DB 0x20
	.DB 0x74
	.DB 0x72
	.DB 0x69
	.DB 0x61
	.DB 0x6C
	.DB 0x0A
	.DB 0x0A
	.DS (1)
.STR@147:
	.DB 0x25
	.DB 0x2A
	.DB 0x5B
	.DB 0x5E
	.DB 0x0A
	.DB 0x5D
	.DS (1)
